#include <gtest/gtest.h>

#include "../utils/denotation.h"

#include "../../include/dlplan/core.h"

using namespace dlplan::core;


namespace dlplan::tests::core {

TEST(DLPTests, RoleIdentity) {
    auto vocabulary = std::make_shared<VocabularyInfo>();
    auto predicate_0 = vocabulary->add_predicate("concept", 1);
    auto instance = std::make_shared<InstanceInfo>(vocabulary, 0);
    auto atom_0 = instance->add_atom("concept", {"A"});
    auto atom_1 = instance->add_atom("concept", {"B"});

    State state_0(instance, {atom_0, atom_1}, 0);

    SyntacticElementFactory factory(vocabulary);

    auto role_0 = factory.parse_role("r_identity(c_primitive(concept,0))");
    EXPECT_EQ(role_0->evaluate(state_0), create_role_denotation(*instance, {{"A","A"},{"B","B"}}));
}

}
